Index: trunk/drmaa_utils/drmaa_utils/logging.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/logging.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/logging.h	(revision 1)
@@ -0,0 +1,102 @@
+/* $Id: logging.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__LOGGING_H
+#define __DRMAA_UTILS__LOGGING_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <stdio.h>
+
+#include <drmaa_utils/compat.h>
+#include <drmaa_utils/util.h>
+
+#define _log_fmt(level, kind, args) \
+	do { \
+		if( (int)fsd_verbose_level <= level ) \
+			_fsd_log( level, __FILE__, __FUNCTION__, kind, \
+					fsd_asprintf args ); \
+	} while(0)
+
+#define _log_empty(level, kind) \
+	do { \
+		if( (int)fsd_verbose_level <= level ) \
+			_fsd_log( level, __FILE__, __FUNCTION__, kind, NULL ); \
+	} while(0)
+
+#define _log_nop \
+	do { /* nothing */ } while(0)
+
+#ifdef DEBUGGING
+#	define fsd_log_trace(args)   _log_fmt(FSD_LOG_TRACE, _FSD_LOG_MSG, args)
+#	define fsd_log_debug(args)   _log_fmt(FSD_LOG_DEBUG, _FSD_LOG_MSG, args)
+#	define fsd_log_enter(args)   _log_fmt(FSD_LOG_TRACE, _FSD_LOG_ENTER, args)
+# define fsd_log_return(args)  _log_fmt(FSD_LOG_TRACE, _FSD_LOG_RETURN, args)
+#else /* ! DEBUGGING */
+#	define fsd_log_trace(args)   _log_nop
+#	define fsd_log_debug(args)   _log_nop
+#	define fsd_log_enter(args)   _log_nop
+#	define fsd_log_return(args)  _log_nop
+#endif
+
+#define fsd_log_info(args)     _log_fmt(FSD_LOG_INFO, _FSD_LOG_MSG, args)
+#define fsd_log_warning(args)  _log_fmt(FSD_LOG_WARNING, _FSD_LOG_MSG, args)
+#define fsd_log_error(args)    _log_fmt(FSD_LOG_ERROR, _FSD_LOG_MSG, args)
+#define fsd_log_fatal(args)    _log_fmt(FSD_LOG_FATAL, _FSD_LOG_MSG, args)
+
+enum{ _FSD_LOG_MSG, _FSD_LOG_ENTER, _FSD_LOG_RETURN };
+void _fsd_log( int level, const char *file, const char *function,
+	int kind, char *message );
+
+void fsd_log_fmt( int level, const char *fmt, ... )
+	__attribute__(( format( printf, 2, 3 ) ));
+
+void fsd_log_fmtv( int level, const char *fmt, va_list args );
+
+void fsd_log_stacktrace( int skip, int limit );
+
+
+/**
+ * Specify place where log messages shall be written.
+ * By default they are written to standard error stream (2).
+ * @param fd   File descriptor to write to.
+ */
+void
+fsd_set_logging_fd( int fd );
+
+typedef enum {
+	FSD_LOG_ALL,
+	FSD_LOG_TRACE,
+	FSD_LOG_DEBUG,
+	FSD_LOG_INFO,
+	FSD_LOG_WARNING,
+	FSD_LOG_ERROR,
+	FSD_LOG_FATAL,
+	FSD_LOG_NONE
+} fsd_verbose_level_t;
+
+void
+fsd_set_verbosity_level( fsd_verbose_level_t level );
+
+extern fsd_verbose_level_t fsd_verbose_level;
+
+#endif /* __DRMAA_UTILS__LOGGING_H */
+
Index: trunk/drmaa_utils/drmaa_utils/xmalloc.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/xmalloc.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/xmalloc.c	(revision 1)
@@ -0,0 +1,190 @@
+/* $Id: xmalloc.c 289 2010-09-14 14:13:17Z mmatloka $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file xmalloc.c
+ * Memory allocation/deallocation routines.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <errno.h>
+#include <limits.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include <drmaa_utils/xmalloc.h>
+#include <drmaa_utils/compat.h>
+#include <drmaa_utils/exception.h>
+#include <drmaa_utils/logging.h>
+
+#ifndef SIZE_T_MAX
+#  define SIZE_T_MAX ((size_t) -1)
+#endif
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: xmalloc.c 289 2010-09-14 14:13:17Z mmatloka $";
+#endif
+
+
+void *
+fsd_malloc_( void **p, size_t size )
+{
+	void *ptr = NULL;
+	if( size )
+	 {
+		ptr = malloc( size );
+		if( ptr )
+			memset( ptr, 0, size );
+		else
+		 {
+			*p = NULL;
+			fsd_exc_raise_sys( errno=ENOMEM );
+		 }
+	 }
+	*p = ptr;
+	return ptr;
+}
+
+
+void *
+fsd_calloc_( void **p, size_t n, size_t size )
+{
+	void *ptr = NULL;
+
+	/*fsd_log_enter(("%d", (int)n));*/
+
+	if( n && size )
+	 {
+		if( n <= SIZE_T_MAX / size )
+			ptr = calloc( n, size );
+		if( !ptr )
+		 {
+			*p = NULL;
+			fsd_exc_raise_sys( errno=ENOMEM );
+		 }
+	 }
+	*p = ptr;
+	return ptr;
+}
+
+
+void *
+fsd_realloc_( void **p, size_t size )
+{
+	void *ptr = *p;
+
+	if( size )
+	 {
+		if( ptr )
+			ptr = realloc( ptr, size );
+		else
+			ptr = malloc( size );
+
+		if( ptr != NULL )
+			*p = ptr;
+		else
+			fsd_exc_raise_sys( errno=ENOMEM );
+	 }
+	else if( ptr != NULL )
+	 {
+		free( ptr );
+		*p = ptr = NULL;
+	 }
+
+	return ptr;
+}
+
+
+void
+fsd_free( void *p )
+{
+	if( p )
+		free( p );
+}
+
+
+int
+fsd_malloc_noraise_( void **p, size_t size )
+{
+	int result = 0;
+	void *ptr = NULL;
+	if( size )
+	 {
+		ptr = malloc( size );
+		if( ptr )
+			memset( ptr, 0, size );
+		else
+			result = ENOMEM;
+	 }
+	*p = ptr;
+	return result;
+}
+
+
+int
+fsd_calloc_noraise_( void **p, size_t n, size_t size )
+{
+	int result = 0;
+	void *ptr = NULL;
+	if( n && size )
+	 {
+		if( n <= SIZE_T_MAX / size )
+			ptr = calloc( n, size );
+		if( !ptr )
+			result = ENOMEM;
+	 }
+	*p = ptr;
+	return result;
+}
+
+
+int
+fsd_realloc_noraise_( void **p, size_t size )
+{
+	int result = 0;
+	void *ptr = *p;
+
+	if( size )
+	 {
+		if( ptr )
+			ptr = realloc( ptr, size );
+		else
+			ptr = malloc( size );
+
+		if( ptr != NULL )
+			*p = ptr;
+		else
+			result = ENOMEM;
+	 }
+	else if( ptr != NULL )
+	 {
+		free( ptr );
+		*p = ptr = NULL;
+	 }
+
+	return result;
+}
+
Index: trunk/drmaa_utils/INSTALL
===================================================================
--- trunk/drmaa_utils/INSTALL	(revision 1)
+++ trunk/drmaa_utils/INSTALL	(revision 1)
@@ -0,0 +1,237 @@
+Installation Instructions
+*************************
+
+Copyright (C) 1994, 1995, 1996, 1999, 2000, 2001, 2002, 2004, 2005,
+2006, 2007 Free Software Foundation, Inc.
+
+This file is free documentation; the Free Software Foundation gives
+unlimited permission to copy, distribute and modify it.
+
+Basic Installation
+==================
+
+Briefly, the shell commands `./configure; make; make install' should
+configure, build, and install this package.  The following
+more-detailed instructions are generic; see the `README' file for
+instructions specific to this package.
+
+   The `configure' shell script attempts to guess correct values for
+various system-dependent variables used during compilation.  It uses
+those values to create a `Makefile' in each directory of the package.
+It may also create one or more `.h' files containing system-dependent
+definitions.  Finally, it creates a shell script `config.status' that
+you can run in the future to recreate the current configuration, and a
+file `config.log' containing compiler output (useful mainly for
+debugging `configure').
+
+   It can also use an optional file (typically called `config.cache'
+and enabled with `--cache-file=config.cache' or simply `-C') that saves
+the results of its tests to speed up reconfiguring.  Caching is
+disabled by default to prevent problems with accidental use of stale
+cache files.
+
+   If you need to do unusual things to compile the package, please try
+to figure out how `configure' could check whether to do them, and mail
+diffs or instructions to the address given in the `README' so they can
+be considered for the next release.  If you are using the cache, and at
+some point `config.cache' contains results you don't want to keep, you
+may remove or edit it.
+
+   The file `configure.ac' (or `configure.in') is used to create
+`configure' by a program called `autoconf'.  You need `configure.ac' if
+you want to change it or regenerate `configure' using a newer version
+of `autoconf'.
+
+The simplest way to compile this package is:
+
+  1. `cd' to the directory containing the package's source code and type
+     `./configure' to configure the package for your system.
+
+     Running `configure' might take a while.  While running, it prints
+     some messages telling which features it is checking for.
+
+  2. Type `make' to compile the package.
+
+  3. Optionally, type `make check' to run any self-tests that come with
+     the package.
+
+  4. Type `make install' to install the programs and any data files and
+     documentation.
+
+  5. You can remove the program binaries and object files from the
+     source code directory by typing `make clean'.  To also remove the
+     files that `configure' created (so you can compile the package for
+     a different kind of computer), type `make distclean'.  There is
+     also a `make maintainer-clean' target, but that is intended mainly
+     for the package's developers.  If you use it, you may have to get
+     all sorts of other programs in order to regenerate files that came
+     with the distribution.
+
+  6. Often, you can also type `make uninstall' to remove the installed
+     files again.
+
+Compilers and Options
+=====================
+
+Some systems require unusual options for compilation or linking that the
+`configure' script does not know about.  Run `./configure --help' for
+details on some of the pertinent environment variables.
+
+   You can give `configure' initial values for configuration parameters
+by setting variables in the command line or in the environment.  Here
+is an example:
+
+     ./configure CC=c99 CFLAGS=-g LIBS=-lposix
+
+   *Note Defining Variables::, for more details.
+
+Compiling For Multiple Architectures
+====================================
+
+You can compile the package for more than one kind of computer at the
+same time, by placing the object files for each architecture in their
+own directory.  To do this, you can use GNU `make'.  `cd' to the
+directory where you want the object files and executables to go and run
+the `configure' script.  `configure' automatically checks for the
+source code in the directory that `configure' is in and in `..'.
+
+   With a non-GNU `make', it is safer to compile the package for one
+architecture at a time in the source code directory.  After you have
+installed the package for one architecture, use `make distclean' before
+reconfiguring for another architecture.
+
+Installation Names
+==================
+
+By default, `make install' installs the package's commands under
+`/usr/local/bin', include files under `/usr/local/include', etc.  You
+can specify an installation prefix other than `/usr/local' by giving
+`configure' the option `--prefix=PREFIX'.
+
+   You can specify separate installation prefixes for
+architecture-specific files and architecture-independent files.  If you
+pass the option `--exec-prefix=PREFIX' to `configure', the package uses
+PREFIX as the prefix for installing programs and libraries.
+Documentation and other data files still use the regular prefix.
+
+   In addition, if you use an unusual directory layout you can give
+options like `--bindir=DIR' to specify different values for particular
+kinds of files.  Run `configure --help' for a list of the directories
+you can set and what kinds of files go in them.
+
+   If the package supports it, you can cause programs to be installed
+with an extra prefix or suffix on their names by giving `configure' the
+option `--program-prefix=PREFIX' or `--program-suffix=SUFFIX'.
+
+Optional Features
+=================
+
+Some packages pay attention to `--enable-FEATURE' options to
+`configure', where FEATURE indicates an optional part of the package.
+They may also pay attention to `--with-PACKAGE' options, where PACKAGE
+is something like `gnu-as' or `x' (for the X Window System).  The
+`README' should mention any `--enable-' and `--with-' options that the
+package recognizes.
+
+   For packages that use the X Window System, `configure' can usually
+find the X include and library files automatically, but if it doesn't,
+you can use the `configure' options `--x-includes=DIR' and
+`--x-libraries=DIR' to specify their locations.
+
+Specifying the System Type
+==========================
+
+There may be some features `configure' cannot figure out automatically,
+but needs to determine by the type of machine the package will run on.
+Usually, assuming the package is built to be run on the _same_
+architectures, `configure' can figure that out, but if it prints a
+message saying it cannot guess the machine type, give it the
+`--build=TYPE' option.  TYPE can either be a short name for the system
+type, such as `sun4', or a canonical name which has the form:
+
+     CPU-COMPANY-SYSTEM
+
+where SYSTEM can have one of these forms:
+
+     OS KERNEL-OS
+
+   See the file `config.sub' for the possible values of each field.  If
+`config.sub' isn't included in this package, then this package doesn't
+need to know the machine type.
+
+   If you are _building_ compiler tools for cross-compiling, you should
+use the option `--target=TYPE' to select the type of system they will
+produce code for.
+
+   If you want to _use_ a cross compiler, that generates code for a
+platform different from the build platform, you should specify the
+"host" platform (i.e., that on which the generated programs will
+eventually be run) with `--host=TYPE'.
+
+Sharing Defaults
+================
+
+If you want to set default values for `configure' scripts to share, you
+can create a site shell script called `config.site' that gives default
+values for variables like `CC', `cache_file', and `prefix'.
+`configure' looks for `PREFIX/share/config.site' if it exists, then
+`PREFIX/etc/config.site' if it exists.  Or, you can set the
+`CONFIG_SITE' environment variable to the location of the site script.
+A warning: not all `configure' scripts look for a site script.
+
+Defining Variables
+==================
+
+Variables not defined in a site shell script can be set in the
+environment passed to `configure'.  However, some packages may run
+configure again during the build, and the customized values of these
+variables may be lost.  In order to avoid this problem, you should set
+them in the `configure' command line, using `VAR=value'.  For example:
+
+     ./configure CC=/usr/local2/bin/gcc
+
+causes the specified `gcc' to be used as the C compiler (unless it is
+overridden in the site shell script).
+
+Unfortunately, this technique does not work for `CONFIG_SHELL' due to
+an Autoconf bug.  Until the bug is fixed you can use this workaround:
+
+     CONFIG_SHELL=/bin/bash /bin/bash ./configure CONFIG_SHELL=/bin/bash
+
+`configure' Invocation
+======================
+
+`configure' recognizes the following options to control how it operates.
+
+`--help'
+`-h'
+     Print a summary of the options to `configure', and exit.
+
+`--version'
+`-V'
+     Print the version of Autoconf used to generate the `configure'
+     script, and exit.
+
+`--cache-file=FILE'
+     Enable the cache: use and save the results of the tests in FILE,
+     traditionally `config.cache'.  FILE defaults to `/dev/null' to
+     disable caching.
+
+`--config-cache'
+`-C'
+     Alias for `--cache-file=config.cache'.
+
+`--quiet'
+`--silent'
+`-q'
+     Do not print messages saying which checks are being made.  To
+     suppress all normal output, redirect it to `/dev/null' (any error
+     messages will still be shown).
+
+`--srcdir=DIR'
+     Look for the package's source code in directory DIR.  Usually
+     `configure' can determine that directory automatically.
+
+`configure' also accepts some other, not widely useful, options.  Run
+`configure --help' for more details.
+
Index: trunk/drmaa_utils/project/project.tmpl
===================================================================
--- trunk/drmaa_utils/project/project.tmpl	(revision 1)
+++ trunk/drmaa_utils/project/project.tmpl	(revision 1)
@@ -0,0 +1,137 @@
+## $Id$
+#encoding utf-8
+#extends project_template.templates.Autotools
+
+#def generated_files
+#return (Autotools.generated_files(self)
+  | set([
+		"m4/ac_c_bigendian_cross.m4",
+		"m4/acx_pthread.m4",
+		"m4/ax_docutils.m4",
+		"m4/ax_func_gettid.m4",
+		"m4/ax_func_va_copy.m4",
+		"m4/ax_gperf.m4",
+		"m4/bison_ylwrap.sh",
+		"Makefile.am",
+		]))
+#end def
+
+#block ac_arguments
+${Autotools.ac_arguments(self)}
+AC_ARG_WITH(drmaa-utils, AC_HELP_STRING([--with-drmaa-utils=...],
+		[used only to detect that drmaa utils is sub packaged]))
+AM_CONDITIONAL([DRMAA_UTILS_STANDALONE],
+		[test x\$with_drmaa_utils = x])
+#end block ac_arguments
+
+#block ac_programs
+${Autotools.ac_programs(self)}
+
+#raw
+\# code generation tools:
+AC_PROG_YACC
+AX_GPERF
+AC_CHECK_PROGS([RAGEL], [ragel], [sh m4/missing-dev-prog.sh ragel])
+
+\# reStructuredText processing:
+AX_DOCUTILS
+\# documentation generation:
+AC_CHECK_PROGS([DOT], [dot])
+if test x$DOT != x; then
+	HAVE_DOT=yes
+else
+	HAVE_DOT=no
+fi
+AC_SUBST([HAVE_DOT])
+#end raw
+#end block ac_programs
+
+#block ac_system
+${Autotools.ac_system(self)}
+
+AC_C_BIGENDIAN_CROSS
+#end block ac_system
+
+
+#block ac_libraries
+#raw
+ACX_PTHREAD([CFLAGS="$CFLAGS $PTHREAD_CFLAGS" LIBS="$PTHREAD_LIBS $LIBS"],
+		[AC_MSG_ERROR([POSIX threads library is required by DRMAA.])])
+#end raw
+#end block ac_libraries
+
+#block ac_headers
+AC_CHECK_HEADERS([execinfo.h fcntl.h inttypes.h libintl.h limits.h malloc.h stddef.h stdint.h stdlib.h string.h sys/time.h unistd.h])
+AC_HEADER_STDBOOL
+AC_HEADER_TIME
+#end block ac_headers
+
+#block ac_types
+AC_TYPE_PID_T
+AC_TYPE_SIZE_T
+AC_TYPE_SSIZE_T
+AC_TYPE_MODE_T
+AC_TYPE_UINT16_T
+AC_TYPE_UINT32_T
+AC_TYPE_UINT8_T
+#end block ac_types
+
+#block ac_structures
+AC_STRUCT_TM
+#end block ac_structures
+
+#block ac_functions
+AC_FUNC_ALLOCA
+AC_FUNC_MALLOC
+AC_FUNC_REALLOC
+AC_FUNC_STRERROR_R
+AC_FUNC_STRFTIME
+AC_CHECK_FUNCS([ \
+	asprintf \
+	fstat \
+	getcwd \
+	gettimeofday \
+	localtime_r \
+	memset \
+	mkstemp \
+	strchr \
+	strdup \
+	strerror \
+	strlcpy \
+	strndup \
+	strstr \
+	vasprintf])
+AX_FUNC_GETTID
+AX_FUNC_VA_COPY
+AC_SEARCH_LIBS([backtrace], [execinfo])
+#end block ac_functions
+
+#block ac_config_files
+AC_CONFIG_FILES([
+	Makefile
+	drmaa_utils/Makefile
+	test/Makefile
+	Doxyfile
+])
+AC_CONFIG_HEADERS([config.h])
+#end block ac_config_files
+
+## #block ac_success_message
+## ${Autotools.ac_success_message(self)}
+## #end block ac_success_message
+
+
+#block top_makefile_am
+${makefile_am_header}
+${top_makefile_am_specific}
+SUBDIRS = drmaa_utils test
+#end block top_makefile_am
+
+#block boring_project_specific
+^drmaa_utils/conf_tab.c$
+^drmaa_utils/conf_tab.h$
+^drmaa_utils/datetime_tab.c$
+^drmaa_utils/datetime_tab.h$
+^drmaa_utils/drmaa_attrib.c$
+^test/test_exception$
+#end block boring_project_specific
Index: trunk/doc/.gitignore
===================================================================
--- trunk/doc/.gitignore	(revision 1)
+++ trunk/doc/.gitignore	(revision 1)
@@ -0,0 +1,10 @@
+doxy
+Doxyfile
+doxy-timestamp
+*.aux
+*.html
+*.log
+*.out
+*.pdf
+*.tex
+*.toc
Index: trunk/doc/Makefile.am
===================================================================
--- trunk/doc/Makefile.am	(revision 1)
+++ trunk/doc/Makefile.am	(revision 1)
@@ -0,0 +1,67 @@
+# $Id: Makefile.am 2623 2009-08-05 12:05:49Z mmamonski $
+# 
+# FedStage DRMAA for PBS Pro
+# Copyright (C) 2006-2009  FedStage Systems
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+docdir=$(datadir)/doc
+pkgdocdir=$(docdir)/@PACKAGE@-@VERSION@
+
+plaintext_doc = \
+ $(top_srcdir)/README \
+ $(top_srcdir)/AUTHORS \
+ $(top_srcdir)/COPYING
+generated_doc = \
+ readme.html \
+ readme.pdf \
+ stylesheet.css \
+ rst.css
+
+EXTRA_DIST = $(generated_doc) readme.tex
+pkgdoc_DATA = $(plaintext_doc) $(generated_doc)
+
+DOCUTILSFLAGS = \
+ -i utf-8 \
+ -o utf-8 \
+ --language=en \
+ --file-insertion-enabled \
+ --no-generator \
+ --tab-width=4
+RST2HTMLFLAGS = $(DOCUTILSFLAGS) \
+ --stylesheet=stylesheet.css \
+ --link-stylesheet
+RST2LATEXFLAGS = $(DOCUTILSFLAGS) \
+ --documentclass=article \
+ --documentoptions=a4paper,10pt \
+ --font-encoding=OT4 \
+ --graphicx-option=pdftex \
+ --use-latex-footnotes \
+ --footnote-references=superscript \
+ --use-latex-citations \
+ --use-latex-toc
+
+readme.html: $(top_srcdir)/README
+	$(RST2HTML) $(RST2HTMLFLAGS) $< $@
+readme.tex: $(top_srcdir)/README
+	$(RST2LATEX) $(RST2LATEXFLAGS) $< $@
+.tex.pdf:
+	pdflatex $< && pdflatex $<
+
+clean-local:
+	-rm -rf *.log *.aux *.toc *.out
+
+MAINTAINERCLEANFILES = readme.html readme.tex readme.pdf drmaa.pdf
+
Index: trunk/project/project.tmpl
===================================================================
--- trunk/project/project.tmpl	(revision 1)
+++ trunk/project/project.tmpl	(revision 1)
@@ -0,0 +1,107 @@
+## $Id: project.tmpl 2420 2009-06-24 14:40:21Z lukasz $
+#encoding utf-8
+#extends project_template.templates.Autotools
+
+#def generated_files
+#return (Autotools.generated_files(self)
+  | set([
+		'm4/acx_pthread.m4',
+		'm4/ax_docutils.m4',
+        'm4/ax_gperf.m4',
+		'm4/ax_drmaa_utils.m4',
+		'm4/ax_pbs.m4',
+	]))
+#end def
+
+#block ac_programs
+${Autotools.ac_programs(self)}
+\# code generation tools:
+AX_GPERF
+## AC_CHECK_PROGS([RAGEL], [ragel], [sh m4/missing-dev-prog.sh ragel])
+
+\# reStructuredText processing:
+AX_DOCUTILS()
+if test x\$RST2HTML = x; then
+	RST2HTML="sh m4/missing-dev-prog.sh docutils"
+fi
+if test x\$RST2LATEX = x; then
+	RST2LATEX="sh m4/missing-dev-prog.sh docutils"
+fi
+#end block ac_programs
+
+#block ac_libraries
+#raw
+ACX_PTHREAD([CFLAGS="$CFLAGS $PTHREAD_CFLAGS" LIBS="$PTHREAD_LIBS $LIBS"],
+		[AC_MSG_ERROR([POSIX threads library is required.])])
+#end raw
+
+AX_DRMAA_UTILS([builtin], [:], [AC_MSG_ERROR([
+drmaa_utils libraries/headers not found]) ])
+
+AX_PBS([:], [AC_MSG_ERROR([
+PBS libraries/headers not found;
+add --with-pbs to set PBS installation root.]) ])
+#raw
+if test ${sysconfdir} == '${prefix}/etc' -a "$prefix" == 'NONE'; then
+	sysconfdir='/etc'
+	ac_configure_args="${ac_configure_args} --sysconfdir=${sysconfdir}"
+fi
+CPPFLAGS="${CPPFLAGS} -DCONFDIR=${sysconfdir}"
+#end raw
+#end block ac_libraries
+
+#block ac_headers
+AC_HEADER_STDC
+AC_HEADER_TIME
+AC_CHECK_HEADERS([stddef.h stdlib.h string.h strings.h sys/time.h unistd.h])
+#end block ac_headers
+
+#block ac_types
+AC_TYPE_SIZE_T
+#end block ac_types
+#block ac_structures
+AC_STRUCT_TM
+#end block ac_structures
+
+#block ac_functions
+AC_FUNC_MALLOC
+AC_FUNC_STRFTIME
+AC_FUNC_VPRINTF
+AC_CHECK_FUNCS([ \
+	asprintf \
+	fstat \
+	getcwd \
+	gettimeofday \
+	localtime_r \
+	memset \
+	mkstemp \
+	setenv \
+	strcasecmp \
+	strchr \
+	strdup \
+	strerror \
+	strlcpy \
+	strndup \
+	strstr \
+	strtol \
+	vasprintf \
+	])
+#end block ac_functions
+
+#block ac_config_files
+AC_CONFIG_FILES([
+	Makefile
+	pbs_drmaa/Makefile
+	doc/Makefile
+])
+AC_CONFIG_HEADERS([config.h])
+AC_CONFIG_SUBDIRS([drmaa_utils])
+#end block ac_config_files
+
+
+#block top_makefile_am
+${makefile_am_header}
+${top_makefile_am_specific}
+SUBDIRS = drmaa_utils pbs_drmaa doc
+#end block top_makefile_am
+
Index: trunk/Makefile.am
===================================================================
--- trunk/Makefile.am	(revision 12)
+++ trunk/Makefile.am	(revision 1)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id: Makefile.am 2420 2009-06-24 14:40:21Z lukasz $
 #
 # FedStage DRMAA for PBS Pro
@@ -24,3 +24,3 @@
  m4/missing-dev-prog.sh
 
-SUBDIRS = drmaa_utils pbs_drmaa
+SUBDIRS = drmaa_utils pbs_drmaa  doc
Index: trunk/test/example.c
===================================================================
--- trunk/test/example.c	(revision 51)
+++ trunk/test/example.c	(revision 1)
@@ -1,3 +1,3 @@
-/* $Id$ */
+/* $Id: example.c 2 2009-10-12 09:51:22Z mamonski $ */
 /*
  *  DRMAA library for Torque/PBS
@@ -41,5 +41,5 @@
 #define EXPORT_ENVS   0
 #define DEBUG         1
-#define N_JOBS        8
+#define N_JOBS        1
 
 #define ERR_LEN      DRMAA_ERROR_STRING_BUFFER
@@ -107,7 +107,7 @@
 		printf( "constructing %d\n", i );
 		sprintf( arg, "%d", i );
-		sprintf( job_path, "/bin/sleep" );
+		sprintf( job_path, "./test_job" );
 		argv[0] = job_path;
-		argv[1] = "5";
+		argv[1] = arg;
 		argv[2] = NULL;
 		for( j = 0;  j < 3;  j++ )
@@ -127,5 +127,5 @@
 #endif
 	 }
-#if ! WITH_BULK
+
 	for( i = 0;  i < N_JOBS;  i++ )
 	 {
@@ -145,12 +145,12 @@
 	 }
 
-#else
-	 {
-		char *argv[] = { "/bin/sleep", "5", "$drmaa_incr_ph$", NULL };
+#if WITH_BULK
+	 {
+		char *argv[] = { "./job", "bulk", "$drmaa_incr_ph$", NULL };
 		char *fds[]  = { "b.$drmaa_incr_ph$.stdin", "b.$drmaa_incr_ph$.stdout",
 			"b.$drmaa_incr_ph$.stderr" };
-		bulk_job = construct_job( argv, fds, "." );
-	 }
-	rc = drmaa_run_bulk_jobs( &bulk_job_ids, bulk_job, 1, N_JOBS, 2, err_msg, ERR_LEN );
+		bulk_job = construct_job( argv, fds, WD );
+	 }
+	rc = drmaa_run_bulk_jobs( &bulk_job_ids, bulk_job, 1, N_JOBS, 1, err_msg, ERR_LEN );
 	if( rc )  drmaa_error("drmaa_run_bulk_jobs");
 
@@ -197,5 +197,11 @@
 #endif
 	const char *scalar_attrs[] = {
+		DRMAA_WD            , NULL,
 		DRMAA_REMOTE_COMMAND, NULL,
+		DRMAA_JOB_NAME      , NULL,
+		DRMAA_INPUT_PATH    , NULL,
+		DRMAA_OUTPUT_PATH   , NULL,
+		DRMAA_ERROR_PATH    , NULL,
+                DRMAA_NATIVE_SPECIFICATION, "-l host=eeyore,nodes=1 -W x=FLAGS:ADVRES:usecase.0",
 		NULL                , NULL
 	};
@@ -216,5 +222,10 @@
 	int rc;
 
-	scalar_attrs[ 1] = "/bin/sleep";
+	scalar_attrs[ 1] = cwd;
+	scalar_attrs[ 3] = argv[0];
+	scalar_attrs[ 5] = "jobname";
+	scalar_attrs[ 7] = fds[0];
+	scalar_attrs[ 9] = fds[1];
+	scalar_attrs[11] = fds[2];
 
 	printf( "allocaing template\n" );
Index: trunk/test/Makefile
===================================================================
--- trunk/test/Makefile	(revision 51)
+++ trunk/test/Makefile	(revision 1)
@@ -1,7 +1,3 @@
-all: example wait
-
 example : example.c
-	gcc example.c -o example -ldrmaa -L/opt/drmaa/torque/lib  -I/opt/drmaa/torque/include
-wait : wait.c
-	gcc wait.c -o wait -ldrmaa -L/opt/drmaa/torque/lib -Wl,-R/opt/drmaa/torque/lib -I/opt/drmaa/torque/include
+	gcc example.c -o example -ldrmaa -ldrmaa_base
       
Index: trunk/m4/ax_gperf.m4
===================================================================
--- trunk/m4/ax_gperf.m4	(revision 12)
+++ trunk/m4/ax_gperf.m4	(revision 1)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id: ax_gperf.m4 2420 2009-06-24 14:40:21Z lukasz $
 #
 # SYNOPSIS
@@ -22,5 +22,5 @@
 # LICENSE
 #
-#   Written by Åukasz CieÅnik <lukasz.ciesnik@gmail.com>
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
 #   and placed under Public Domain
 #
Index: trunk/m4/ax_gcc_warnings.m4
===================================================================
--- trunk/m4/ax_gcc_warnings.m4	(revision 12)
+++ trunk/m4/ax_gcc_warnings.m4	(revision 1)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id: ax_gcc_warnings.m4 2420 2009-06-24 14:40:21Z lukasz $
 #
 # SYNOPSIS
@@ -7,5 +7,5 @@
 # DESCRIPTION
 #
-#   Check for supported gcc options.
+#   Check for LSF libraries and headers.
 #
 #   This macro calls::
@@ -20,5 +20,5 @@
 # LICENSE
 #
-#   Written by Åukasz CieÅnik <lukasz.ciesnik@gmail.com>
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
 #   and placed under Public Domain.
 #
Index: trunk/m4/ax_pbs.m4
===================================================================
--- trunk/m4/ax_pbs.m4	(revision 103)
+++ trunk/m4/ax_pbs.m4	(revision 1)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id: ax_pbs.m4 2420 2009-06-24 14:40:21Z lukasz $
 #
 # SYNOPSIS
@@ -21,8 +21,6 @@
 # LICENSE
 #
-#   Written by Åukasz CieÅnik <lukasz.ciesnik@gmail.com>
-#   and placed under Public Domain. 
-#   
-#   Further contribution: Mariusz Mamonski <mamonski@man.poznan.pl> 
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
+#   and placed under Public Domain
 #
 
@@ -30,7 +28,4 @@
 AC_ARG_WITH([pbs], [AC_HELP_STRING([--with-pbs=<pbs-prefix>],
 		[Path to existing PBS installation root])])
-AC_ARG_ENABLE([disable-pbs-log], [AC_HELP_STRING([--disable-pbs-log],
-		[Do not use liblog while linking with PBS Professional])])
-		
 AC_SUBST(PBS_INCLUDES)
 AC_SUBST(PBS_LIBS)
@@ -38,5 +33,4 @@
 
 if test x"$with_pbs" != x; then
-	PBS_HOME=$with_pbs
 	PBS_INCLUDES="-I${with_pbs}/include "
 	PBS_LDFLAGS="-L${with_pbs}/lib "
@@ -47,10 +41,8 @@
 		PBS_HOME=`dirname $T2`
 		PBS_INCLUDES="-I${PBS_HOME}/include "
-		PBS_LDFLAGS="-L${PBS_HOME}/lib "
+        	PBS_LDFLAGS="-L${PBS_HOME}/lib "
 	fi
 fi
 
-
-PBS_INCLUDES="$PBS_INCLUDES -I${PBS_HOME}/include/torque "
 LDFLAGS_save="$LDFLAGS"
 CPPFLAGS_save="$CPPFLAGS"
@@ -61,13 +53,4 @@
 
 AH_TEMPLATE([PBS_PROFESSIONAL], [compiling against PBS Professional])
-AH_TEMPLATE([PBS_PROFESSIONAL_NO_LOG], [Do not use liblog while linking with PBS Professional])
-AH_TEMPLATE([HAVE_PBS_SUBMIT_HASH], [Torque 4 pbs_submit_hash function found])
-
-if test x"$enable_pbs_log" != "xno"; then
-	ax_pbs_lib_log=" -llog"
-else
-	ax_pbs_lib_log=""
-	AC_DEFINE(PBS_PROFESSIONAL_NO_LOG,[1])
-fi
 
 if test x"$ax_pbs_ok" = xno; then
@@ -76,5 +59,5 @@
 	AC_CHECK_LIB([log], [pbse_to_txt], [:], [ax_pbs_ok="no"])
 	if test x"$ax_pbs_ok" = xyes; then
-		ax_pbs_libs="-lpbs $ax_pbs_lib_log"
+		ax_pbs_libs="-lpbs -llog"
 	fi
 fi
@@ -88,9 +71,8 @@
 	AC_CHECK_LIB([log], [pbse_to_txt], [:], [ax_pbs_ok="no"], [-lssl -lcrypto] )
 	if test x"$ax_pbs_ok" = xyes; then
-		ax_pbs_libs="-lpbs $ax_pbs_lib_log -lssl -lcrypto"
+		ax_pbs_libs="-lpbs -llog -lssl -lcrypto"
 	fi
 fi
 
-ax_pbs_submit_hash="no"
 
 if test x"$ax_pbs_ok" = xno; then
@@ -98,18 +80,10 @@
  	AC_CHECK_LIB([torque], [pbs_submit], [:], [ax_pbs_ok="no"])
  	AC_CHECK_LIB([torque], [pbse_to_txt], [:], [ax_pbs_ok="no"])
-	AC_CHECK_LIB([torque], [pbs_submit_hash], [AC_DEFINE(HAVE_PBS_SUBMIT_HASH) ax_pbs_submit_hash="yes"], [:])
-
-
  	if test x"$ax_pbs_ok" = xyes; then
  		ax_pbs_libs="-ltorque"
  	fi
-
-	AM_CONDITIONAL([PBS_PROFESSIONAL], [false])
 else
 	AC_DEFINE(PBS_PROFESSIONAL,[1])
-	AM_CONDITIONAL([PBS_PROFESSIONAL], [true])
 fi
-
-AM_CONDITIONAL([TORQUE4], [test x$ax_pbs_submit_hash = xyes])
 
 if test x"$ax_pbs_ok" = xyes; then
